Attribute VB_Name = "AutoOpen"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' IPress (C) 2001,2002,2003 Estndard Lingstic S.L.
'   versi 1.1rev7
'   Concepte i diseny per Ricard Prez
'   Programat per Gerardo Garca
'   Tots els drets reservats.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Private Function ZZZ_GetComplementaryFile(sArchivoComp As String, sFilesPath As String, tipo_active As Integer) As String
  Dim lista_try As New Collection
  Dim lista_find As New Collection
  Dim fname As String
  Dim fname2 As String
  Dim i As Long, j As Long
  Dim msgtxt As String
     ' Averiguamos los ficheros que estan disponibles
     ' esto lo conseguimos cargando en una lista todos los nombres posibles
     ' y posteriormente probandolos uno por uno
  If tipo_active = ZZZ_IdTargetText Then
    lista_try.Add sArchivoComp + ".doc"
    lista_try.Add sArchivoComp + ".txt"
    lista_try.Add sArchivoComp + ".spl.txt"
    lista_try.Add sArchivoComp + ".spl.doc"
    lista_try.Add sArchivoComp + "_spl.txt"
    lista_try.Add sArchivoComp + "_spl.doc"
  Else
    lista_try.Add sArchivoComp + ".lxp.txt"
    lista_try.Add sArchivoComp + ".lxp.doc"
    lista_try.Add sArchivoComp + "_lxp.txt"
    lista_try.Add sArchivoComp + "_lxp.doc"
  End If

    ' Construimos la lista de ficheros que existen
  For i = 1 To lista_try.Count
    If lista_try(i) = Dir(sFilesPath & lista_try(i)) Then
      lista_find.Add lista_try(i)
    End If
  Next i
  
    ' Ordenamos los ficheros por orden cronologico (el primero el ms nuevo)
  For i = 1 To lista_find.Count - 1
    For j = 1 To lista_find.Count - 1
      If FileDateTime(sFilesPath + lista_find(j)) < FileDateTime(sFilesPath + lista_find(j + 1)) Then
        fname = lista_find(j)
        lista_find.Remove j
        lista_find.Add fname
      End If
    Next
  Next
  
    ' Elegimos un fichero de la lista
  If lista_find.Count > 1 Then
      ' Construimos la lista de la ventana
    For i = 1 To lista_find.Count
      ZZZ_SelectFileWindow.ffound.AddItem lista_find(i)
    Next
      ' Abrimos la ventanita con la lista de ficheros
    ZZZ_SelectFileWindow.Show
    ZZZ_GetComplementaryFile = ZZZ_SelectFileWindow.SelectedFile
      ' Reseteamos (destrozamos) la ventanita
    Set ZZZ_SelectFileWindow = Nothing
  Else
    If lista_find.Count = 0 Then
        ' NO HAY NINGUN FICHERO EN LA LISTA
      ZZZ_GetComplementaryFile = ""
    Else
        ' SOLO HAY UN CANDIDATO
      If tipo_active = ZZZ_IdTargetText Then
        msgtxt = "He trobat el fitxer '" & lista_find(i) & "', que sembla la versi original d'aquest document. Desitja que l'obri automticament i el prepari per treballar amb l'eina IPress?"
      Else
        msgtxt = "He trobat el fitxer '" & lista_find(i) & "', que sembla la versi traduda d'aquest document. Desitja que l'obri automticament i el prepari per treballar amb l'eina IPress?"
      End If
      If MsgBox(msgtxt, vbYesNo, "Activar IPress?") = vbYes Then
        ZZZ_GetComplementaryFile = lista_find(i)
      Else
        ZZZ_GetComplementaryFile = ""
      End If
    End If
  End If
End Function

Private Sub zzz_openDocumentOnXP(ByVal sCompruebaArchivo As String)
    Documents.Open filename:=sCompruebaArchivo, Visible:=True
End Sub

Private Sub zzz_openDocumentOn97(ByVal sCompruebaArchivo As String)
    Documents.Open filename:=sCompruebaArchivo
End Sub

Private Sub zzz_FixWindowsOn97(ByVal tipo_active As Long, _
                               ByRef actiDoc As Document, _
                               ByRef otherDoc As Document)
  Dim win As Window
  
  If tipo_active = ZZZ_IdTargetText Then
    actiDoc.Activate
    For Each win In actiDoc.Windows
      win.WindowState = wdWindowStateMinimize
    Next win
  Else
    otherDoc.Activate
    For Each win In otherDoc.Windows
      win.WindowState = wdWindowStateMinimize
    Next win
  End If
End Sub

Private Sub zzz_FixWindowsOnXP(ByVal tipo_active As Long, _
                               ByRef actiDoc As Document, _
                               ByRef otherDoc As Document)
  Dim win As Window
  
  actiDoc.Activate
  For Each win In actiDoc.Windows
    win.Visible = True
  Next win
  otherDoc.Activate
  For Each win In otherDoc.Windows
    win.Visible = True
  Next win
End Sub
Private Function ZZZ_openAndInitFiles() As Boolean
  Dim filename As String
  Dim sCompruebaArchivo As String
  Dim sArchivoComp As String
  Dim otherDoc As Document
  Dim actiDoc As Document
'
  Dim tipo_active As Integer      ' Indica el tipo del documento activo
  Dim tipo_other As Integer       ' Indica el tipo esperado en el other
  Dim existe_txt As Boolean       ' Indica si el other existe como txt
  Dim existe_doc As Boolean       ' Indica si el other existe como doc
'
  Dim active_marked As Boolean    ' Indica si el doc activo esta marcado
  Dim active_family As String     ' active_marked => La 'family' del doc activo
  Dim active_mtipo As Integer     ' active_marked => El 'tipo' del doc activo
'
  
    ' Por defecto (en caso de que salieramos de golpe) informariamos como
    ' fracaso en la carga del source y su traduccion
  ZZZ_openAndInitFiles = False
    
    ' Obtenemos el nombre del fichero abierto
  Set actiDoc = ActiveDocument
  filename = ZZZ_nombreFichero(actiDoc.name)
    
    ' Averiguamos el Path del documento y lo completamos.
  sCompruebaArchivo = actiDoc.Path + "\"
    ' Primero nos aseguramos que no estemos abriendo un fichero de internet
    ' o de alguna fuente sospechosa, que dara error si se intentase abrir!
    ' Para eso buscamos el encabezado 'http://' o 'ftp://' que son las dos
    ' posibles fuentes ms probables de documentos de internet.
  If StrComp(Left(sCompruebaArchivo, 4 + 1 + 2), "http://", vbTextCompare) = 0 Or _
     StrComp(Left(sCompruebaArchivo, 3 + 1 + 2), "ftp://", vbTextCompare) = 0 Then
     Exit Function
  End If
    ' Tambin, para cazar casos especiales, buscamos caracteres prohibidos
    ' en sistemas de ficheros de Microsoft. Eso al menos nos asegura, con bastante
    ' probabilidad, que no abran accesos a lugares extraos, sistemas de ficheros
    ' remotos o virtuales.
  If sCompruebaArchivo Like "*[/*?]*" Then
     Exit Function
  End If
    ' Comprobamos el tipo de fichero, y generamos el nombre del hermano
    ' Si no es un tipo conocido, terminamos
  If ((ZZZ_compruebaTipo(actiDoc.FullName, ".lxp.txt")) Or _
      (ZZZ_compruebaTipo(actiDoc.FullName, ".lxp.doc")) Or _
      (ZZZ_compruebaTipo(actiDoc.FullName, "_lxp.txt")) Or _
      (ZZZ_compruebaTipo(actiDoc.FullName, "_lxp.doc"))) Then
      ' Al parecer el documento abierto es una traduccin
    sArchivoComp = Left(filename, Len(filename) - 4)
    tipo_active = ZZZ_IdTargetText
    tipo_other = ZZZ_IdSourceText
  ElseIf ((ZZZ_compruebaTipo(actiDoc.FullName, ".txt")) Or _
          (ZZZ_compruebaTipo(actiDoc.FullName, ".doc")) Or _
          (ZZZ_compruebaTipo(actiDoc.FullName, ".spl.txt")) Or _
          (ZZZ_compruebaTipo(actiDoc.FullName, ".spl.doc")) Or _
          (ZZZ_compruebaTipo(actiDoc.FullName, "_spl.txt")) Or _
          (ZZZ_compruebaTipo(actiDoc.FullName, "_spl.doc"))) Then
      ' Al parecer el documento abierto es el original
    If ((ZZZ_compruebaTipo(actiDoc.FullName, ".spl.txt")) Or _
        (ZZZ_compruebaTipo(actiDoc.FullName, ".spl.doc")) Or _
        (ZZZ_compruebaTipo(actiDoc.FullName, "_spl.txt")) Or _
        (ZZZ_compruebaTipo(actiDoc.FullName, "_spl.doc"))) Then
      sArchivoComp = Left(filename, Len(filename) - 4)
    Else
      sArchivoComp = filename
    End If
    tipo_active = ZZZ_IdSourceText
    tipo_other = ZZZ_IdTargetText
  Else
      ' Estamos tratando con un tipo de documento que no conocemos o
      ' no tiene nada que ver con nuestros objetivos
    Exit Function
  End If
  
    ' Verificamos si el fichero 'active' esta marcado.
    ' Si esta internamente marcado, guardamos su familia y identidad.
  active_marked = ZZZ_IsMarked(actiDoc)
  If active_marked Then
    active_family = ZZZ_ObtenerFamily(actiDoc)
    active_mtipo = ZZZ_ObtenerId(actiDoc)
    
    If active_mtipo <> tipo_active Then
      tipo_active = tipo_other
      tipo_active = active_mtipo
    End If
  End If
  
    ' Comprobamos si existen varias versiones del documento complementario
    ' y observamos cual es la mas nueva y damos a elegir al usuario
  sArchivoComp = ZZZ_GetComplementaryFile(sArchivoComp, sCompruebaArchivo, tipo_active)
  sCompruebaArchivo = sCompruebaArchivo + sArchivoComp
  If sArchivoComp = "" Then
    Exit Function
  End If
    ' Observamos si existen marcas en el texto en el fichero original.
    ' Si no esta marcado, solo marcamos los parrafos.
  ZZZ_PreparingWindow.done = 0
  ZZZ_PreparingWindow.rel_total = 50
  If Not ZZZ_DetectaMarcas(actiDoc) Then
    ZZZ_insertarMarcas actiDoc, True
  Else
    ZZZ_OcultaMarcas actiDoc, True
  End If
  
  ZZZ_PreparingWindow.done = 50
  ZZZ_PreparingWindow.rel_total = 50
  
    ' Abrimos el fichero otherDoc
  ChangeFileOpenDirectory (actiDoc.Path)
  If Val(Application.Version) < 10 Then
    zzz_openDocumentOn97 sCompruebaArchivo ' Versin para Word 97
  Else
    zzz_openDocumentOnXP sCompruebaArchivo ' Versin para Word XP
  End If
  
  Set otherDoc = Documents(sArchivoComp)
  'Window
  otherDoc.Activate
  ZZZ_PreparingWindow.Repaint
  
    ' Miramos si esta marcado.
    ' En el caso de que lo estuviera, miramos si el otro esta marcado
    ' y seguimos el comportamiento dictado por esta tabla:
    '
    '  .------------------------------------------------------------------------------.
    '  | Active marcado? | Other marcado? | Entonces...                               |
    '  |-----------------|----------------|-------------------------------------------|
    '  |       no        |       no       | Family = filename y OK                    |
    '  |       no        |       si       | Family = Other(family) y OK               |
    '  |       si        |       no       | Family = Active(family) y OK              |
    '  |       si        |       si       | Si Other(family) = Active(family) Then Ok |
    '  `------------------------------------------------------------------------------
    '
  
  If ZZZ_IsMarked(otherDoc) Then
    If active_marked Then
      If active_family <> ZZZ_ObtenerFamily(otherDoc) Then
        If MsgBox("El fitxer original i la seva versi traduda no semblen ser germans. He de forar ambdos per poder treballar com si ho fossin?", vbYesNo, "Ull! Compte!") = vbYes Then
          ZZZ_MarcaDoc actiDoc, active_family, tipo_active
          ZZZ_MarcaDoc otherDoc, active_family, tipo_other
        Else
          'actiDoc.Close SaveChanges:=wdDoNotSaveChanges
          otherDoc.Close SaveChanges:=wdDoNotSaveChanges
          Exit Function
        End If
      End If
      If tipo_active <> ZZZ_ObtenerId(otherDoc) Then
        'If MsgBox("El fitxer '" + sArchivoComp + "' se esperava del tipus: " & tipo_other & ", pero es va trobar el tipus " & ZZZ_ObtenerId(otherDoc) & ". Forar al tipus que se esperava?", vbYesNo, "Ull! Compte!") = vbYes Then
          ZZZ_MarcaDoc otherDoc, active_family, tipo_other
        'Else
        '  'actiDoc.Close SaveChanges:=wdDoNotSaveChanges
        '  otherDoc.Close SaveChanges:=wdDoNotSaveChanges
        '  Exit Function
        'End If
      End If
    Else
      ZZZ_MarcaDoc actiDoc, ZZZ_ObtenerFamily(otherDoc), tipo_active
    End If
  Else
    If active_marked Then
      ZZZ_MarcaDoc otherDoc, active_family, tipo_other
    Else
      ZZZ_MarcaDoc actiDoc, filename, tipo_active
      ZZZ_MarcaDoc otherDoc, filename, tipo_other
    End If
  End If
  
    ' Si el otherDoc no esta marcado entonces lo marcamos.
  If Not ZZZ_DetectaMarcas(otherDoc) Then
    ZZZ_insertarMarcas otherDoc, True
  Else
    ZZZ_OcultaMarcas otherDoc, True
  End If
  
    ' Arreglamos el aspecto de la ventana con la traduccion
  If Val(Application.Version) < 10 Then
    zzz_FixWindowsOn97 tipo_active, actiDoc, otherDoc ' Versin para Word 97
  Else
    zzz_FixWindowsOnXP tipo_active, actiDoc, otherDoc ' Versin para Word XP
  End If

    ' Activamos la barra de herramientas
  ZZZ_Barra.ZZZ_generaIPressToolBar
  
  ZZZ_openAndInitFiles = True
End Function

'Main cuando abrimos el fichero
Public Function ZZZ_empiezaYaElAutoOpen()
  ZZZ_empiezaYaElAutoOpen = ZZZ_openAndInitFiles
  ZZZ_PreparingWindow.fin_tareas
End Function


Public Sub AutoOpen()
  WordBasic.Disableautomacros 1
  ZZZ_Preparing.GoPreparing 1
  WordBasic.Disableautomacros 0
End Sub

