Attribute VB_Name = "ZZZ_Parsing"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' IPress (C) 2001,2002,2003 Estndard Lingstic S.L.
'   versi 1.1rev7
'   Concepte i diseny per Ricard Prez
'   Programat per Gerardo Garca i Emilio Gmez
'   Tots els drets reservats.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Const idEsp = 0
Const idCat = 1
Const maxOptLength = 250


' ESTA FUNCIN PARSEA LOS CASOS: *tururu; **'tururu'; ***'tururu'
Public Function ZZZ_ParsePrimeraSegundaOp(ByRef sel_end_op As Long, ByRef type_alt As String) As Collection
  Dim sel_start As Long
  Dim sel_end As Long
  Dim r As Range
  Dim col As Collection
        
  Set col = New Collection
  
  sel_start = 0
  sel_end = 0
  sel_end_op = 0
  type_alt = ""        ' De momento no es ninguna alternativa
  
  Selection.Collapse
  
  If Selection.Characters.First = "*" Then
    ' Bien. Tenemos el primer arterisco. Nos falta el resto.
    Selection.MoveRight wdCharacter, 1
    type_alt = "*"
    If Selection.Characters.First = "*" Then
      ' Hay otro arterisco y parece de la forma **
      Selection.MoveRight wdCharacter, 1
      type_alt = "**"
      If Selection.Characters.First = "'" Then
        ' Comienza por ' y esperamos **'XXXX'
        ' ntese que sel_start y sel_end marcarn principio y fin de la alternativa
        type_alt = "**'"
        Selection.MoveRight wdCharacter, 1
        sel_start = Selection.Start
        If Selection.MoveStartUntil("'") = 0 Then
          Set ZZZ_ParsePrimeraSegundaOp = col
          Exit Function
        End If
        sel_end = Selection.End
        Selection.MoveRight wdCharacter, 1
        sel_end_op = Selection.End
      ElseIf Selection.Characters.First = "*" Then
        ' Es un caso *** y esperamos obligatoriamente ***'XXXX'
        ' ntese que sel_start y sel_end marcarn principio y fin de la alternativa
        Selection.MoveRight wdCharacter, 1
        If Selection.Characters.First = "'" Then
          type_alt = "***'"
          Selection.MoveRight wdCharacter, 1
          sel_start = Selection.Start
          If Selection.MoveStartUntil("'") = 0 Then
            Set ZZZ_ParsePrimeraSegundaOp = col
            Exit Function
          End If
          sel_end = Selection.End
          Selection.MoveRight wdCharacter, 1
          sel_end_op = Selection.End
        End If
      End If
    End If
    If sel_start = sel_end And (Not ZZZ_IsSpace(Selection.Characters.First)) And (Selection.Characters.First <> "'") Then
      ' Al parecer se trata del caso *[*]XXXX. Hacemos que sel_start y sel_end marquen
      ' el principio y final de la alternativa XXXX
      sel_start = Selection.Start
      Selection.MoveRight wdWord, 1
      sel_end = Selection.End
      If sel_end > sel_start Then
        While sel_start < sel_end And ZZZ_IsSpace(ActiveDocument.Range(sel_end - 1, sel_end).Text)
          ' Si el ultimo caracter de la seleccin es un espacio o un tabulador,
          ' no lo hacemos formar parte de la seleccin.
          sel_end = sel_end - 1
        Wend
      Else
        type_alt = ""
      End If
      sel_end_op = sel_end
    End If
  End If
  
  ' Si tenemos una seleccin vlida (de ms de 0 caracteres) aadimos a la lista
  ' de alternativas, la opcin (sea frase o palabra)
  If ((sel_start < sel_end) And ((sel_end - sel_start) < maxOptLength)) Then
    Set r = ActiveDocument.Range(Start:=sel_start, End:=sel_end)
    col.Add r.Text
    Set r = Nothing
  End If
  
  Set ZZZ_ParsePrimeraSegundaOp = col
End Function

' PARSEA OPCIONES DE LA FORMA { xx; yy }
Public Function ZZZ_ParseTerceraOp(ByRef sel_end As Long, ByRef type_alt As String) As Collection
  Dim sel_start As Long
  Dim fin As Boolean
  Dim col As Collection
  Dim r As Range
  
  ' Comenzamos una nueva coleccion
  Set col = New Collection
  
  ' Nos situamos al principio de la primera cosa {XX;...}
  If Selection.Characters.First = "{" Then
    type_alt = "{"
    Selection.MoveRight wdCharacter, 1
    sel_start = Selection.Start
    
    ' Vamos pateandonos las cosas...
    fin = False
    While ((Selection.MoveStartUntil(";}" & Chr$(13)) > 0) And (Not fin))
      If Selection.Characters.First = ";" Then
        sel_end = Selection.End - 1
        Set r = ActiveDocument.Range(Start:=sel_start, End:=sel_end)
        col.Add r.Text
        Selection.MoveRight wdCharacter, 1
        Selection.MoveRight wdCharacter, 1
        sel_start = Selection.Start
      ElseIf Selection.Characters.First = "}" Then
        sel_end = Selection.End
        Set r = ActiveDocument.Range(Start:=sel_start, End:=sel_end)
        col.Add r.Text
        Selection.MoveRight wdCharacter, 1
        sel_end = Selection.Start
        fin = True
      ElseIf Selection.Characters.First = Chr$(13) Then
        Set col = New Collection
        type_alt = ""
        sel_end = Selection.Start
        fin = True
      Else
        MsgBox "ZZZ_ParseTerceraOp(): No entenc que faig per aqui!"
        fin = True
      End If
    Wend

    ' Si hemos salido porque el tag esta incompleto, simplemente devolvemos nada
    If Not fin Then
      Set col = New Collection
      sel_end = 0
      type_alt = ""
    End If
  Else
    ' Hemos comenzado con mal pie
    type_alt = ""
  End If
  
  ' El caso de una unica opcion [opcion], aunque sintacticamente correcto,
  ' semanticamente es una chorrada. Nos lo saltamos.
  If col.Count = 1 Then
    Set col = New Collection
    type_alt = ""
  End If
  
  Set ZZZ_ParseTerceraOp = col
End Function

' EN ESTA OPCION PARSEAMOS LAS FORMAS xxx//yyyy///
Public Function ZZZ_ParseCuartaOp(ByRef sel_start_op As Long, ByRef sel_end_op As Long, ByRef type_alt As String) As Collection
  Dim sel_start As Long
  Dim sel_begin As Long
  Dim sel_end As Long
  Dim sel_start2 As Long
  Dim fin As Boolean
  Dim col As Collection
  Dim r As Range
  
    ' Creamos una coleccion nueva y vacia
  Set col = New Collection
  type_alt = ""
  
    ' Nos apuntamos donde hemos empezado el parsing
  sel_begin = Selection.Start
  Selection.MoveRight wdCharacter, 1
  If Selection.Characters.First = "/" Then
    ' Hemos comprobado de verdad que existe una segunda barra,
    ' de momento tenemos garantizado //XXXX
    ' donde XXXX puede ser [xxx | yyy] o xxxx
    ' Ahora detectamos cuala es la palabra alternativa
    Selection.MoveRight wdCharacter, 1
    sel_start = Selection.Start
    fin = False
    While ((Selection.MoveStartUntil("/[") > 0) And (Not fin))
      If Selection.Characters.First = "[" Then
        ' Hemos encontrado una alternativa, la parseamos mas que nada para
        ' saltarnosla y seguir en la busqueda de nuestra preciada barra de
        ' finalizacion
        ZZZ_ParseQuintaOp sel_end, type_alt
        Selection.Start = sel_end
      ElseIf Selection.Characters.First = "/" Then
        ' Hemos encontrado de momento //XXXX/. Eso es bueno. Ahora faltar
        ' comprobar si el resto es correcto!!!
        fin = True
        sel_end = Selection.Start
      End If
    Wend
    ' La activacin del flag 'fin' delata que la primera fase ha ido ms
    ' o menos bien. La segunda fase consiste en completar las comprobaciones,
    ' es decir: que finaliza con tres barras (///) y empieza por un palabro.
    If fin Then
      Selection.MoveRight wdCharacter, 1
      If Selection.Characters.First = "/" Then
        Selection.MoveRight wdCharacter, 1
        If Selection.Characters.First = "/" Then
          ' Bien! De momento tenemos //XXXX///, ahora nos quedamos con la palabra
          ' de la izquierda y en paz!
          Selection.MoveRight wdCharacter, 1
          sel_end_op = Selection.Start
            ' Obtenemos la primera opcin
          Selection.Start = sel_begin
          Selection.MoveLeft wdWord, 2
          sel_start_op = Selection.Start
          Set r = ActiveDocument.Range(Start:=Selection.Start, End:=sel_begin)
          col.Add r.Text
            ' Obtenemos la segunda opcin
          Set r = ActiveDocument.Range(Start:=sel_start, End:=sel_end)
          col.Add r.Text
          Selection.Start = sel_end_op
          type_alt = "//"
        Else
          ' Vaya, falsa alarma... solo teniamos //XXXX//
          Set col = New Collection
          sel_end_op = 0
        End If
      Else
        ' Otra falsa alarma... solo teniamos //XXXX/
        Set col = New Collection
        sel_end_op = 0
      End If
    Else
      ' Fracaso total. No es ni por asomo una opcin YYYY//XXXX///
      Set col = New Collection
      sel_end_op = 0
    End If
  Else
    ' Solo era una barra suelta en la inmensidad del documento.
    ' Abandonamos todo intento de parsing.
    Set col = New Collection
    sel_end_op = 0
  End If
  
  ' Devolvemos nuestras conclusiones al parser superior
  Set ZZZ_ParseCuartaOp = col
End Function

' EN ESTA OPCION PARSEAMOS LAS COSITAS [xxx | yyy | zzz]
Public Function ZZZ_ParseQuintaOp(ByRef sel_end As Long, ByRef type_alt As String) As Collection
  Dim col As Collection
  Dim r As Range
  Dim i As Integer
  Dim sel_start As Long
  Dim error As Boolean
  
  ' Comenzamos asumiendo que no tenemos nada, a parte de las esperanzas de encontrar
  ' una opcin
  Set col = New Collection
  type_alt = "["
  
  ' Comenzamos por saltarnos el bracket sobre el que "tendramos" que estar
  ' (SIN DUDA ESTO SE TENDRA QUE CONSIDERAR COMO UNA PRECONDICIN).
  ' Y luego, sin ms dilacin comenzamos a parsearlo todo en busca de las
  ' diferentes alternativas hasta encontrarnos con un ']'.
  Selection.MoveRight wdCharacter, 1
  Selection.Collapse
  
  sel_start = Selection.Start
  i = 1
  error = False
  Do While ((i > 0) And (Selection.MoveStartUntil("[|]" & Chr$(13)) > 0) And Not error)
    If Selection.Characters.First = "[" Then
      ' Estamos en una recursividad. Nos preparamos para sudar de las siguientes
      ' estructuras [ .. | .. ]
      i = i + 1
      Selection.MoveRight wdCharacter, 1
      Selection.Collapse wdCollapseEnd
    ElseIf Selection.Characters.First = "]" Then
      ' Cierre!!!! aun as puede ser que estemos en una recursividad...
      If i = 1 Then
        ' La ultima recursividad... puede ser la ultima palabra de la alternativa...
        sel_end = Selection.End
        Set r = ActiveDocument.Range(Start:=sel_start, End:=sel_end)
        col.Add r.Text
      End If
      i = i - 1
      Selection.MoveRight wdCharacter, 1
      Selection.Collapse
      ' Si en cambio era un verdadero fin de la alternativa... acabamos!
      If i = 0 Then Exit Do
    ElseIf Selection.Characters.First = "|" Then
      ' Otra posible opcin pal bote...
      If i = 1 Then
        sel_end = Selection.End - 1
        If sel_end < sel_start Then
          ' Esto es para cuando tenemos un error de parsing en casos como seran
          ' los siguientes: [| xxx | yyy]; [xxx| yyy]; [xxx |yyy]; [xxx | yyy |]
          col.Add ""
          Selection.Start = sel_start
          Selection.MoveRight wdCharacter, 1
          Selection.MoveRight wdCharacter, 1
          sel_start = Selection.Start
        Else
          ' ol! pal bote!
          Set r = ActiveDocument.Range(Start:=sel_start, End:=sel_end)
          col.Add r.Text
          Selection.MoveRight wdCharacter, 1
          Selection.MoveRight wdCharacter, 1
          sel_start = Selection.Start
        End If
      Else
        ' no es opcin pal bote. Resulta que estamos en una recursividad.
        Selection.MoveRight wdCharacter, 1
      End If
    ElseIf Selection.Characters.First = Chr$(13) Then
      sel_end = Selection.Start
      error = True
    Else
      ' Si entramos aqu posiblemente es que el Word dentro de poco
      ' dar un error fatal, sea de paginacin o de esoterismo avanzado.
      MsgBox "ZZZ_ParseQuintaOp:() Que faig jo aqu?", vbCritical, "IPress Parser Fatal Error"
      i = 0
    End If
  Loop
  
  ' Si i <= 0 quiere decir que las cosas no han ido del todo bien.
  ' Puede ser que no fuese una alternativa o estuviese mal escrita.
  If i > 0 Or error Then
    Set col = New Collection
    sel_end = 0
    type_alt = ""
  Else
    sel_end = Selection.End
  End If
  
  ' El caso de una unica opcion [opcion], aunque sintacticamente correcto,
  ' semanticamente es una chorrada. Nos lo saltamos.
  If col.Count = 1 Then
    Set col = New Collection
    type_alt = ""
  End If
  
  Set ZZZ_ParseQuintaOp = col
End Function

' AVERIGUAMOS SI ES UNA LETRA MAYSCULA O ALGO QUE SE LE PAREZCA
Public Function ZZZ_IsUCase(ByVal a As String) As Boolean
  ZZZ_IsUCase = (((a >= "A") And (a <= "Z")) Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = ""))
End Function

' AVERIGUAMOS SI ES UNA LETRA MINSCULA O ALGO QUE SE LE PAREZCA.
Public Function ZZZ_IsLCase(ByVal a As String) As Boolean
  ZZZ_IsLCase = (((a >= "a") And (a <= "z")) Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = "") Or _
                 (a = "") Or (a = ""))
End Function

' AVERIGUA SI ESTAMOS TRATANDO CON UNA VOCAL O ALGO SIMILAR
Public Function ZZZ_IsUawehlEnCastellano(ByVal a As String) As Boolean
  ZZZ_IsUawehlEnCastellano = ZZZ_IsLCase(a) Or ZZZ_IsUCase(a)
End Function

' AVERIGUA SI ESTAMOS TRATANDO CON UN CARACTER QUE PUEDE FORMAR PARTE
' DE UNA PALABRA O ALGO SIMILAR.
Public Function ZZZ_IsLectehr(ByVal a As String) As Boolean
  ZZZ_IsLectehr = ZZZ_IsUawehlEnCastellano(a) Or _
              ((a >= "0") And (a <= "9")) Or _
              (a = "") Or _
              (a = "-") Or _
              (a = "") Or _
              (a = "")
End Function

' AVERIGUA SI LO QUE TENEMOS ES UN ESPACIO, SALTO DE LINEA, TABULADOR... O CUALQUIER
' CARACTER DE SEPARACIN DE PALABRAS
Public Function ZZZ_IsSpace(ByVal a As String) As Boolean
  ZZZ_IsSpace = (a = " ") Or (a = Chr$(13)) Or (a = Chr$(9)) Or (a = Chr$(10))
End Function

' AVERIGUA SI HAY ALGN TEXTO CON SENTIDO AGRADABLE EN EL RANGO INDICADO.
Public Function ZZZ_IsThereTextInRange(ByRef a As Range) As Boolean
  Dim i As Integer
  Dim fin As Boolean
  
  i = 1
  fin = False
  While ((Not fin) And (i < a.Characters.Count))
    fin = Not ZZZ_IsSpace(a.Characters(i))
    i = i + 1
  Wend
  
  ZZZ_IsThereTextInRange = fin
End Function

' AVERIGUA SI HAY ALGUNA LETRA MAYSCULA (O PARECIDA) EN EL STRING PASADO.
' ** DEBERA REVISARSE ESTA FUNCIN YA QUE NO INSPIRA MUCHA CONFIANZA **
Public Function ZZZ_ExisteMayuscula(ByVal str As String) As Boolean
  Dim a As String
  Dim i As Integer
  Dim lastspace As Boolean
  Dim mayus As Boolean
  
  mayus = False
  i = 1
  While ((Not mayus) And (i < Len(str)))
    a = Mid$(str, i, 1)
    If Not ZZZ_IsLectehr(a) Then
      lastspace = True
    Else
      If ZZZ_IsUCase(a) Then
        mayus = True
      End If
      lastspace = False
    End If
    i = i + 1
  Wend
  
  ZZZ_ExisteMayuscula = mayus
End Function

' AVERIGUA SI HAY ALGUNA PALABRA EN MAYSCULAS O ALGO PARECIDO
Public Function ZZZ_HayPalabroMayusculo(ByRef col As Collection) As Boolean
  Dim str As String
  Dim mayus As Boolean
  Dim varilo As Variant
  
  mayus = False
  For Each varilo In col
    If Not mayus Then
      str = varilo
      mayus = ZZZ_ExisteMayuscula(str)
    End If
  Next
  ZZZ_HayPalabroMayusculo = mayus
End Function

' EL MONSTRUO QUE LO PARSEA TODO
Public Function ZZZ_ParseaOpcion(ByRef mayus As Boolean, ByRef rec_jump As Long, ByRef sel_end As Long, ByRef type_alt As String) As Collection
  Dim a As String
  Dim sel_start As Long
  Dim sel_start_quart As Long
  Dim col As Collection
  
  Selection.Collapse
  ' Llamamos al parser para que construya la lista de opciones
  a = Selection.Characters.First
  sel_start = Selection.Start
  If a = "*" Then
    Set col = ZZZ_ParsePrimeraSegundaOp(sel_end, type_alt)
    rec_jump = sel_end
  ElseIf a = "{" Then
    Set col = ZZZ_ParseTerceraOp(sel_end, type_alt)
    rec_jump = sel_start + 1
  ElseIf a = "/" Then
    Set col = ZZZ_ParseCuartaOp(sel_start_quart, sel_end, type_alt)
    If sel_end > 0 Then
      sel_start = sel_start_quart
    End If
    rec_jump = sel_end
  ElseIf a = "[" Then
    Set col = ZZZ_ParseQuintaOp(sel_end, type_alt)
    rec_jump = sel_start + 1
  Else
    Set col = New Collection
    rec_jump = sel_start + 1
  End If

  If col.Count = 0 Then
    sel_end = sel_start
    Selection.Start = sel_start
    Selection.End = sel_end
    Selection.MoveRight wdCharacter, 1
  Else
    Selection.Start = sel_start
    Selection.End = sel_end
  End If
  
  mayus = ZZZ_HayPalabroMayusculo(col)
  
  Set ZZZ_ParseaOpcion = col
End Function

' EL MONSTRUO QUE NO SOLO PARSEA, SINO QUE ENCIMA BUSCA.
Public Function ZZZ_BuscaYParseaOpcion(ByRef mayus As Boolean, ByRef rec_jump As Long, ByRef sel_end As Long, ByRef type_alt As String) As Collection
  Dim col As Collection
  Dim fin As Boolean
  
  mayus = False
  
  ' Nos aseguramos de que haya almenos 1 documento!
  If Documents.Count > 0 Then
      ' Si es necesario hacemos un Collapse de la seleccion
    If Selection.End > Selection.Start Then Selection.Start = Selection.End
    
      ' Buscamos el principio de algo que pueda ser una opcion
    fin = False
    Do
      If Selection.MoveStartUntil("*{/[") > 0 Then
        Set col = ZZZ_ParseaOpcion(mayus, rec_jump, sel_end, type_alt)
        fin = (col.Count > 0)
      Else
        Set col = New Collection
        fin = True
      End If
    Loop While Not fin
  Else
    Set col = New Collection
  End If
  
  Set ZZZ_BuscaYParseaOpcion = col
End Function

' CONSTRUCTOR DE TRIPLETAS DE BUILDUCASEOFADOC
' las tripletas son de la forma < palabra, ande comienza, ande acaba >
Public Sub ZZZ_AddUCaseSimpleElement(ByRef col As Collection, _
                                     Optional ByVal word As String = "", _
                                     Optional ByVal poss As Long = 0, _
                                     Optional ByVal pose As Long = 0)
  If word = "" Or poss < 0 Or pose < 0 Then
    word = ""
    poss = -1
    pose = -1
  End If
  col.Add word
  col.Add poss
  col.Add pose
End Sub

' CONSTRUYE UNA LISTA DE TRIPLETAS CON INFO SOBRE MAYSCULAS DE UN RANGO.
Public Function ZZZ_BuildUCaseOfADoc(ByRef doc As Document, ByRef rng As Range) As Collection
  Dim col As Collection, stubcol As Collection
  Dim posa As Long, pose As Long, poss As Long
  Dim dummy_long As Long, dummy_long2 As Long
  Dim fin As Boolean, es_l_geminada As Boolean, detw As Boolean, mayus As Boolean
  Dim achar As String, word As String

  Set col = New Collection
  posa = rng.Start

  While Not fin
    achar = doc.Range(posa, posa).Characters.First.Text
      ' Avanzamos en el documento
    If posa + 1 >= rng.End Then
      es_l_geminada = False
    Else
      es_l_geminada = (detw And achar = "." And ZZZ_IsLectehr(doc.Range(posa + 1, posa + 1).Characters.First.Text))
    End If
    If ZZZ_IsLectehr(achar) Or es_l_geminada Then
      ' Si se trata de una letra...
      If detw Then
        ' Y estamos dentro de una palabra detectada
        posa = posa + 1
        pose = posa
      Else
        ' Empezamos una palabra nueva
        If ZZZ_IsUCase(achar) Then
          ' Y en mayusculas!
          detw = True
          poss = posa
          posa = posa + 1
          pose = posa
        Else
          ' En minusculas, asi que la ignoramos un poco
          detw = False
          posa = posa + 1
        End If
      End If
    Else
      ' Hemos encontrado algo que no es una letra
      If detw Then
        ' Como buscabamos palabra, la recogemos
        word = doc.Range(poss, pose).Text
        ZZZ_AddUCaseSimpleElement col, word, poss, pose
        detw = False
      Else
        If ((achar = "{") Or (achar = "[") Or (achar = "/") Or (achar = "*")) Then
          ' Es un caracter sagrado, lo parseamos
          ' Activamos el documento y ponemos el cursor bien
          doc.Activate
          Selection.Start = posa
          Selection.End = posa
          ' Parseamos
          Set stubcol = ZZZ_ParseaOpcion(mayus, dummy_long, dummy_long2, "")
          If stubcol.Count > 0 Then
            If mayus Then
              detw = False
              poss = Selection.Start
              pose = Selection.End
              word = doc.Range(poss, pose).Text
              ZZZ_AddUCaseSimpleElement col, word, poss, pose
              posa = Selection.End
            Else
              detw = False
              posa = Selection.End
            End If
          Else
            posa = posa + 1
          End If
          Selection.Collapse wdCollapseEnd
        Else
          posa = posa + 1
        End If
      End If
    End If
    If posa >= rng.End Then
      fin = True
    End If
  Wend

  Set ZZZ_BuildUCaseOfADoc = col
End Function

' CONSTRUYE UNA LISTA DE MAYSCULAS DE DOS DOCUMENTOS PARA POSTERIORMENTE CONTRASTAR
' LOS DATOS QUE CONTIENE
'
' ORGANIZA UNA LISTA CON ELEMENTOS DE LA FORMA
'             {<tripleta_original>,<tripleta_traduccion>}
' la tripleta (DEBE) es:
'          - palabra
'          - pos donde comienza
'          - pos/long donde acaba
Public Function ZZZ_BuildUCaseTranslationList(ByRef docsrc As Document, ByRef docTrg As Document, ByRef rngSrc As Range, ByRef rngTrg As Range) As Collection
  Dim col As Collection
  Dim col1 As Collection
  Dim col2 As Collection
  Dim i As Integer
  Dim rescol As Collection
  
    ' Inicializamos la coleccion final
  Set col = New Collection
  
    ' Creamos las listas de palabras en mayuscula
  Set col1 = ZZZ_BuildUCaseOfADoc(docsrc, rngSrc)
  Set col2 = ZZZ_BuildUCaseOfADoc(docTrg, rngTrg)
  
    ' Corregimos las listas en los casos especiales
  '********************************************************
  Set col1 = ZZZ_FixUCaseList(docsrc, col1, idEsp)
  Set col2 = ZZZ_FixUCaseList(docTrg, col2, idCat)
  
    ' Aqui es donde se paralelizan ambas listas
    ' (construccion de la lista global 'col')
  i = 1
  While i <= col1.Count Or i <= col2.Count
    If i <= col1.Count Then
      ZZZ_AddUCaseSimpleElement col, col1(i), col1(i + 1), col1(i + 2)
    Else
      ZZZ_AddUCaseSimpleElement col
    End If
    If i <= col2.Count Then
      ZZZ_AddUCaseSimpleElement col, col2(i), col2(i + 1), col2(i + 2)
    Else
      ZZZ_AddUCaseSimpleElement col
    End If
    i = i + 3
  Wend
  
    ' Devolvemos el resultado
  Set ZZZ_BuildUCaseTranslationList = col
End Function

Public Function ZZZ_FixUCaseList(ByRef doc As Document, ByRef col As Collection, id As Integer) As Collection
  Dim ExcepListEsp As New Collection
  Dim ExcepListCat As New Collection
  Dim newcol As New Collection
  Dim trobat As Boolean
  Dim i As Integer
  Dim ex As Variant
  Dim elem As String
  Dim n_col As Integer
  Dim rng As Range
  Dim prueba As String
  Dim c As String
  Dim x As Long
  Dim y As Long
  Dim z As Integer
  Dim seg As Boolean
  Dim algo As Boolean
  Dim guion As Boolean
  'Crea las listas de excepciones que hay que encontrar
  
  Set ExcepListEsp = New Collection 'lista castellano
  With ExcepListEsp
    .Add ("A")
    .Add ("AL")
    .Add ("ALS")
    .Add ("AMB")
    .Add ("CON")
    .Add ("D")
    .Add ("DE")
    .Add ("DEL")
    .Add ("DELS")
    .Add ("EL")
    .Add ("L")
    .Add ("ELL")
    .Add ("ELS")
    .Add ("EN")
    .Add ("L")
    .Add ("LA")
    .Add ("LO")
    .Add ("LAS")
    .Add ("LES")
    .Add ("LOS")
    .Add ("PARA")
    .Add ("PEL")
    .Add ("PELS")
    .Add ("PER")
    .Add ("POR")
    .Add ("MIEDO")

  End With
  
  Set ExcepListCat = New Collection 'lista cataln
  With ExcepListCat
    .Add ("A")
    .Add ("AL")
    .Add ("ALS")
    .Add ("AMB")
    .Add ("CON")
    .Add ("D")
    .Add ("DE")
    .Add ("DEL")
    .Add ("DELS")
    .Add ("EL")
    .Add ("L")
    .Add ("ELL")
    .Add ("ELS")
    .Add ("EN")
    .Add ("L")
    .Add ("LA")
    .Add ("LO")
    .Add ("LAS")
    .Add ("LES")
    .Add ("LOS")
    .Add ("PARA")
    .Add ("PEL")
    .Add ("PELS")
    .Add ("PER")
    .Add ("POR")
    .Add ("MIEDO")

  End With
  
  If col.Count >= 3 Then
    If Not ZZZ_EsAltern(col.Item(1)) Then
      n_col = col.Count
      newcol.Add (col.Item(1))
      newcol.Add (col.Item(2))
      newcol.Add (col.Item(3))
      i = 1 + 3
    Else
      If col.Count >= 6 Then
    
        If ZZZ_AlternGuion(doc, col.Item(3), col.Item(5)) Then
          n_col = col.Count
          newcol.Add (col.Item(1) + "-" + col.Item(4))
          newcol.Add (col.Item(2))
          newcol.Add (col.Item(6))
          i = 1 + 6
    
        Else
      
          n_col = col.Count
          newcol.Add (col.Item(1))
          newcol.Add (col.Item(2))
          newcol.Add (col.Item(3))
          i = 1 + 3
        End If
      Else
        n_col = col.Count
        newcol.Add (col.Item(1))
        newcol.Add (col.Item(2))
        newcol.Add (col.Item(3))
        i = 1 + 3
      End If
    End If
  End If
  'Busca si hay excepiones en el prrafo
  
  
  While (i < n_col)
    elem = UCase(col(i))
    trobat = False
    seg = False
    
    If id = idEsp Then
      For Each ex In ExcepListEsp
        If ex = elem Then
          'MsgBox "coincidencia! --> " + col(i)
          trobat = True
          Exit For
        End If
      Next
    Else
    'mira si hay un guion despus de una alternativa
      
      If algo Then
        If ZZZ_AlternGuion(doc, col.Item(i - 1), col.Item(i + 1)) = True Then
          guion = True
          seg = True
        End If
      End If

      
      If Not ZZZ_EsAltern(elem) Then
        For Each ex In ExcepListCat
          If ex = elem Then
            'MsgBox "coincidencia! --> " + col(i)
            trobat = True
            Exit For
          End If
        Next
      Else
        algo = True
        If ZZZ_BuscaAltern(elem, 2, ExcepListCat) Then
          trobat = True
        End If
      End If
    End If
    
      'Comprueba si la excepcin encontrada es addiacente a la anterior mayscula
      If trobat Then
          x = newcol.Item(newcol.Count)
          y = col.Item(i + 1)
          Set rng = doc.Range(x, y)
          prueba = Trim(rng.Text)
            If prueba <> "" Then
              For z = 1 To Len(prueba)
                c = Mid(prueba, z, 1)
                If c <> Chr$(9) Then
                  Exit For
                Else
                  seg = True
                End If
              Next
            Else
              seg = True
            End If
        End If
      'Aade la excepcin a la palabra mayscula anterior
      If seg = True Then
        Dim fusion As String
        Dim pos As Long
    
        newcol.Remove (newcol.Count)
        pos = newcol.Item(newcol.Count)
        newcol.Remove (newcol.Count)
        fusion = newcol.Item(newcol.Count)
        newcol.Remove (newcol.Count)
    
        If algo = True And guion = True Then
          fusion = fusion + "-" + col.Item(i)
          algo = False
          guion = False
        Else
          fusion = fusion + " " + col.Item(i)
        End If
          newcol.Add (fusion)
          newcol.Add (pos)
          newcol.Add (col.Item(i + 2))
          n_col = col.Count
      Else
        newcol.Add (col.Item(i))
        newcol.Add (col.Item(i + 1))
        newcol.Add (col.Item(i + 2))
      End If
      i = i + 3
  Wend
  
  'Retorna la coleccin
  Set ZZZ_FixUCaseList = newcol
  
End Function
Private Function ZZZ_EsAltern(e As String) As Boolean

Dim p As String
Dim f As String

        p = Mid(e, 1, 1)
        f = Mid(e, Len(e), 1)
        If p = "[" And f = "]" Then
            ZZZ_EsAltern = True
        Else
            ZZZ_EsAltern = False
        End If

End Function

Private Function ZZZ_BuscaAltern(e As String, pos As Long, c As Collection) As Boolean
  Dim ex As Variant
  Dim a As Long
  Dim l As String
  Dim str As String
  Dim fin As Boolean

  fin = False
  a = pos
  While Not fin
    str = ""
    l = Mid(e, a, 1)
    a = a + 1
    While l <> "|" And l <> "]"
      str = str + l
      If a > Len(e) Then
        ' error! no era algo parseable!
        ZZZ_BuscaAltern = False
        Exit Function
      End If
      l = Mid(e, a, 1)
      a = a + 1
    Wend
    
    str = Trim(str)
    
    If l = "]" Then
      fin = True
    End If
    
    For Each ex In c
      If ex = str Then
        ZZZ_BuscaAltern = True
        Exit Function
      End If
    Next
  Wend
      
  ZZZ_BuscaAltern = False
End Function

Private Function ZZZ_AlternGuion(doc As Document, alt As Variant, sig As Variant) As Boolean

  Dim rng As Range
  Dim guion As String
  Set rng = doc.Range(alt, sig)
  guion = Trim(rng.Text)
    If guion = "-" Then
      ZZZ_AlternGuion = True
    Else
      ZZZ_AlternGuion = False
    End If
End Function
